'''
Created on Apr 3, 2010

@author: thebwt
'''
import pyglet.app
from pyglet.event import EVENT_HANDLED, EVENT_UNHANDLED

from wengine.modes import BaseMode
from base.models.map import GameMap
from base.models.widgets import WindowWidget, ButtonWidget, WindowManager

class GameMode(BaseMode):

	def __init__(self):
		super(GameMode, self).__init__()
		self.map = GameMap()
		self.gui = None
		self.action = None
		self.wm = WindowManager((200,200))
		
	def on_draw(self):
		super(GameMode, self).on_draw()
		self.map.draw()
		if self.map.over: self.map.over.draw()

	def on_mouse_motion(self,x,y,dx,dy):
		ret = EVENT_UNHANDLED
		self.map.overTile(x,y)
		ret = EVENT_HANDLED
		return ret

	def on_mouse_press(self, x, y, buttons, mods):
		pass
	
	def start(self):
		for window in pyglet.app.windows:
			window.push_handlers(self.wm)

	def close(self):
		for window in pyglet.app.windows:
			window.pop_handlers()


def gameMode():
	for window in pyglet.app.windows:
		window.dispatch_event('mode_change', GameMode())

def window():
	bob = WindowWidget("New Game")
	bob.add_component(ButtonWidget("Start Game", func = gameMode))
	return bob
