import sys
import os
'''
Check if we are working in the source tree or from the installed
package and mangle the python path accordingly
'''
if os.path.dirname(sys.argv[0]) != ".":
	if sys.argv[0][0] == "/":
		fullPath = os.path.dirname(sys.argv[0])
	else:
		fullPath = os.getcwd() + "/" + os.path.dirname(sys.argv[0])
else:
	fullPath = os.getcwd()
sys.path.insert(0, os.path.dirname(fullPath))

import pyglet.resource

from wengine.game import Game
from base.modes.newRoot import RootMode
from base.modes.game import window as game_window
from base.modes.chat import host_window as chat_host_window
from base.modes.chat import connect_window as chat_connect_window

if __name__ == '__main__':
	pyglet.resource.path = ['../art']
	pyglet.resource.reindex()
	game = Game()
	options = (
			("New Game", game_window()),
			("Host Chat", chat_host_window()),
			("Chat Connect", chat_connect_window()),
			)
	game.force_mode(RootMode(options = options))
	game.run()
