'''
Created on Apr 3, 2010

@author: thebwt
'''
from pyglet.image import SolidColorImagePattern
from pyglet.graphics import Batch, OrderedGroup
from pyglet.sprite import Sprite
import pyglet.app

class BaseMode(object):
	'''
	An empty mode

	This mode is just enough to run a wengine 'Game'.

	The primary attribute to be concearned with is 'backgroundColor'
	which, does as implied.

	Background holds the vertex list for an 800x600 background.
	More resolution independant stuff is TODO.

	buttonLists, children, and hidden are of questionable use and
	likely to change soon, so they wont be documneted yet.

	When a BaseMode is 'equiped' by wengine.game.Game, it is 
	passed to pyglet.window.Window.push_handlers. Therefore a 
	BaseMode can implement all the events of pyglet.window.Window .
	'''


	def __init__(self, backgroundColor = (255,255,255)):
		'''
		backgroundColor - Sets the background color. Use this to
		set the color before 'background' is computed. Changing
		backgroundColor after init is pointless.
		'''
		for wind in pyglet.app.windows:
			self.win = wind
		self.feature = Batch()
		self.backgroundGroup = OrderedGroup(1)
		self.featureGroup = OrderedGroup(2)
		self.buttonLists = []
		self.children = []
		self.background = Sprite(SolidColorImagePattern((
			backgroundColor[0],
			backgroundColor[1],
			backgroundColor[2],
			255
			)).create_image(800,600), batch = self.feature, group = self.backgroundGroup)

	def on_draw(self):
		"""
		Implements the on_draw event & draws the background
		"""
		self.feature.draw()

	def start(self):
		pass

	def close(self):
		pass
